'----------------------------------------------------------------
'       Devline.
'   1.0.0  19.11.2019 (bag@prolan.ru)
'----------------------------------------------------------------
Option Explicit

Const DATE_INDEX = 0
Const COMPUTERNAME_INDEX = 1
Const DNS_COMPUTERNAME_INDEX = 2
Const DOMAINNAME_INDEX = 3
Const USERACCOUNTNAME_INDEX = 4
Const USERDISPLAYNAME_INDEX = 5
Const DEPARTMENT_INDEX = 6
Const SCREENSHOT_FILE_INDEX = 7
Const PROCESS_NAME_INDEX = 8
Const WINDOW_TITLE_INDEX = 9
Const BUSINESS_OPERATION_INDEX = 10
Const MORE_INFO_INDEX = 11
Const CONFIG_FILE_KEY_INDEX = 12
Const LOCATION_NAME_INDEX = 13
Const LOCATION_KEY_INDEX = 14
Const LOCATION_CUSTOM_DESCRIPTION_INDEX = 15
Const EVENT_CATEGORY_NUMBER_INDEX = 16
Const EVENT_CATEGORY_NAME_INDEX = 17
Const EVENT_CATEGORY_KEY_INDEX = 18
Const INCIDENT_TYPE_NAME_INDEX = 19
Const INCIDENT_TYPE_KEY_INDEX = 20
Const INCIDENT_TYPE_CUSTOM_DESCRIPTION_INDEX = 21
Const DESCRIPTION_INDEX = 22
Const ADD_BUTTON_CATEGORY_INDEX = 23
Const ADD_BUTTON_ALIAS_INDEX = 24
Const ADD_BUTTON_INFO_INDEX = 25
Const ADD_BUTTON_QUESTION_ID = 26
Const ADD_BUTTON_QUESTION_TEXT = 27
Const ADD_BUTTON_ANSWER_TEXT = 28
Const WAV_FILE_INDEX = 29
Const ENV_STR_PAIR = 30
Const ADD_BUTTON_POS_ID = 31

Const adTypeBinary = 1
Const adTypeText = 2

'-----------------------------------------------------------------------------------------
'     
'
' : arrParams -    32 . :
'          0 - / 
'          1 -  . 
'          2 -    ,  mycomp.office.prolan.ru
'          3 -  .       ,    .
'          4 -        .
'          5 -   ,   
'          6 -  ,  
'          7 -   ( )      . .     .
'          8 -        ( notepad.exe). .
'          9 -    ()     . .
'          10 - -,      (   ). .
'          11 -    ,   .. .
'          12 -  ()    . .
'          13 - " / ". .
'          14 -  () " / ". .
'          15 -    " / ". .
'          16 -  " ". .
'          17 - " ". .
'          18 -  () " ". .
'          19 - " /FAQ". .
'          20 -  () " /FAQ". .
'          21 -    " /FAQ". .
'          22 -  . .
'          23 -  ()   . .    ,    .
'          24 -  ()   . .    ,    .
'          25 -    . .    ,    .
'          26 - ID    Loyalty Reporter  CXMOnline. .     -  0.
'          27 -  . .    ,    .
'          28 -  . .    ,    .
'          29 -    ( ). .   .     .
'          30 -  . . : <name1>=<value1>;<name2>=<value2>;....<nameN>=<valueN>
'          31 - ID POS   Loyalty Reporter  CXMOnline. .     -  0.
'
'    2- :
'    0: .   . 0 -   | 1 -    .
'    1: .
'                       0,     
'                       1,     .
'------------------------------------------------------------------------------------------

Function CustomAction(ByVal arrParams)
  On Error Resume Next
  Err.Clear

  'stop

  CustomAction = Array(1, " .")
  
  If Not IsArray(arrParams) Then
     CustomAction = Array(1, "     .")
     Exit Function
  End If

  If UBound(arrParams) < 30 Then
     CustomAction = Array(1, "       .")
     Exit Function
  End If

  If arrParams(ADD_BUTTON_QUESTION_ID) = 0 Then
     CustomAction = Array(1, "        .")
     Exit Function
  End If

  '  ADD_BUTTON_INFO_INDEX    (  )
  Dim sCurPanelName : sCurPanelName = arrParams(ADD_BUTTON_INFO_INDEX)
  Dim sHardPanelName : sHardPanelName = ""

  '  x .
  Dim arrEnvStringPair : arrEnvStringPair = Split(arrParams(ENV_STR_PAIR), ";", -1, vbTextCompare)
  Dim EnvStrPair, aEnvVariable, sName, sValue

  For Each EnvStrPair in arrEnvStringPair
    aEnvVariable = Split(EnvStrPair, "=", 2)
    If UBound(aEnvVariable) = 1 Then
      sName = Trim(aEnvVariable(0))
      sValue = Trim(aEnvVariable(1))
      If UCase(sName) = "PANEL" Then
        sHardPanelName = sValue
        Exit For
      End If
    End If
  Next

  Dim l_fso, l_oWshShell

  ' ===================================================
  Set l_fso = CreateObject("Scripting.FileSystemObject")
  If Err.number <> 0 Then
    CustomAction = Array(1, "   'Scripting.FileSystemObject': " & Err.Description)
    Exit Function
  End If

  ' ===================================================
  Set l_oWshShell = CreateObject("WScript.Shell")
  If Err.number <> 0 Then
    CustomAction = Array(1, "   'WScript.Shell': " & Err.Description)
    Exit Function
  End If

  '  
  Dim l_strParametersFile
  l_strParametersFile = l_oWshShell.SpecialFolders("MyDocuments") & "\ProLAN\EPMAgent\Scripts\Custom\CreateDevlineEventParams.txt"

  '    ?
  If Not l_fso.FileExists(l_strParametersFile) Then
    CustomAction = Array(1, "  '" & l_strParametersFile & "'  .")
    Exit Function
  End If

  Dim l_objTextStream : Set l_objTextStream = l_fso.OpenTextFile(l_strParametersFile, 1)
  If Err.number <> 0 Then
    CustomAction = Array(1, "    '" & l_strParametersFile & "':" & Err.Description)
    Exit Function
  End If

  Dim l_strOneLine, l_FirstSymbol
  Dim l_strCurSection, l_arrOneLine
  Dim l_strUrl : l_strUrl = ""
  Dim l_strUser : l_strUser = ""
  Dim l_strPassword : l_strPassword = ""
  Dim l_arrLocation : l_arrLocation = Array
  Dim l_nDefaultCamera : l_nDefaultCamera = -1
  Dim l_arrQuestionAlias : l_arrQuestionAlias = Array

  l_strCurSection = ""

  Do While l_objTextStream.AtEndOfStream = False
    l_strOneLine = Trim(l_objTextStream.ReadLine)
    If Len(l_strOneLine) > 0 Then
      l_FirstSymbol = Mid(l_strOneLine, 1, 1)
      If l_FirstSymbol <> "#" AND l_FirstSymbol <> "'" Then
        Select Case UCase(l_strOneLine)
          Case "[DEVLINESERVER]"
            l_strCurSection = "[DEVLINESERVER]"
          Case "[LOCATION]"
            l_strCurSection = "[LOCATION]"
          Case "[DEFAULT_CAMERA]"
            l_strCurSection = "[DEFAULT_CAMERA]"
          Case "[QUESTION_ALIAS]"
            l_strCurSection = "[QUESTION_ALIAS]"
          Case Else
            If l_strCurSection <> "" Then
              l_arrOneLine = Split(l_strOneLine, vbTab, -1)
              If UBound(l_arrOneLine) = 1 Then
                Select Case l_strCurSection
                  Case "[DEVLINESERVER]"
                    '  URL, USER, PWD
                    Select Case UCase(l_arrOneLine(0))
                      Case "URL"
                        l_strUrl = l_arrOneLine(1)
                      Case "USER"
                        l_strUser = l_arrOneLine(1)
                      Case "PWD"
                        l_strPassword = l_arrOneLine(1)
                    End Select
                  Case "[LOCATION]"
                    '     
                    If IsNumeric(l_arrOneLine(1)) Then
                      Redim Preserve l_arrLocation(Ubound(l_arrLocation)+1)
                      l_arrLocation(Ubound(l_arrLocation)) = Array(CStr(Trim(l_arrOneLine(0))), CInt(Trim(l_arrOneLine(1))))
                    End If
                  Case "[QUESTION_ALIAS]"
                    '     
                    If IsNumeric(Trim(l_arrOneLine(0))) Then
                      Redim Preserve l_arrQuestionAlias(Ubound(l_arrQuestionAlias)+1)
                      l_arrQuestionAlias(Ubound(l_arrQuestionAlias)) = Array(CInt(Trim(l_arrOneLine(0))), CStr(Trim(l_arrOneLine(1))))
                    End If
                End Select
              ElseIf UBound(l_arrOneLine) = 0 Then
                If l_strCurSection = "[DEFAULT_CAMERA]" Then
                  If IsNumeric(l_arrOneLine(0)) And l_nDefaultCamera = -1 Then
                    l_nDefaultCamera = CInt(l_arrOneLine(0))
                  End If
                End If
              Else
                CustomAction = Array(1, "  http  '" & l_strParametersFile & "'      " & l_strCurSection)
                Exit Function
              End If
            End If
        End Select
      End If
    End If
  Loop
  
  l_objTextStream.Close

  '    ?
  If l_strUrl = "" Then
    CustomAction = Array(1, "  '" & l_strParametersFile & "'    [DEVLINESERVER]   URL  .")
    Exit Function
  End If

  If l_strUser = "" Then
    CustomAction = Array(1, "  '" & l_strParametersFile & "'    [DEVLINESERVER]   USER  .")
    Exit Function
  End If

  If l_strPassword = "" Then
    CustomAction = Array(1, "  '" & l_strParametersFile & "'    [DEVLINESERVER]   PWD  .")
    Exit Function
  End If

  '  l_arrQuestionAlias  ,  ,        
  If UBound(l_arrQuestionAlias) >= 0 Then
    Dim found : found = False
    For i = 0 To UBound(l_arrQuestionAlias)
      If l_arrQuestionAlias(i)(0) = arrParams(ADD_BUTTON_QUESTION_ID) Then
        If (l_arrQuestionAlias(i)(1) = "*") Or (UCase(arrParams(ADD_BUTTON_ALIAS_INDEX)) = UCase(l_arrQuestionAlias(i)(1))) Then
          found = True
          Exit For
        End If
      End If
    Next

    If Not found Then
      CustomAction = Array(0, "     / .")
      Exit Function
    End If
  End If

  '      
  Dim i
  Dim sPanelNane : sPanelNane = ""
  Dim sPanelOwnerName : sPanelOwnerName = ""

  If sHardPanelName = "" Then
     sPanelNane = sCurPanelName
  Else
     sPanelNane = sHardPanelName
     sPanelOwnerName = sCurPanelName
  End If

  '   ,   sPanelNane
  Dim l_nCameraNumber : l_nCameraNumber = -1
  For i = 0 To UBound(l_arrLocation)
    If UCase(l_arrLocation(i)(0)) = UCase(sPanelNane) Then
      l_nCameraNumber = l_arrLocation(i)(1)
      Exit For
    End If
  Next

  If l_nCameraNumber = -1 Then
    l_nCameraNumber = l_nDefaultCamera
  End If


  '     HTTP/HTTPS 
  Dim l_oHttpRequest
  Set l_oHttpRequest = CreateObject("WinHttp.WinHttpRequest.5.1")

  If Err.number <> 0 Then
    CustomAction = Array(1, "   'WinHttp.WinHttpRequest.5.1': " & Err.Description)
    Exit Function
  End If

  CustomAction = DoHttpRequest(l_oHttpRequest, sPanelNane, sPanelOwnerName, arrParams(ADD_BUTTON_QUESTION_TEXT), arrParams(ADD_BUTTON_ANSWER_TEXT), l_strUrl, l_strUser, l_strPassword, l_nCameraNumber)

  Set l_oHttpRequest = Nothing

End Function

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Function DoHttpRequest(ByRef oHttpRequest, sPanelNane, sPanelOwnerName, sQuestionText, sAnswerText, sUrl, sUser, sPassword, nCameraNumber)
  On Error Resume Next

  oHttpRequest.Open "POST", sUrl, false

  If Err.number <> 0 Then
    DoHttpRequest = Array(1, "     : " & Err.Description)
    Exit Function
  End If

  Dim sOriginalBearer: sOriginalBearer = sUser & ":" & sPassword

  oHttpRequest.SetRequestHeader "Content-Type", "application/json"
  oHttpRequest.SetRequestHeader "Authorization", "Basic " & Base64Encode(sOriginalBearer)

  Dim sBody
  sBody = "{ ""source"" : "" "", ""name"" : """ & sPanelNane
  If Len(sPanelOwnerName) > 0 Then
    sBody = sBody & " [" & sPanelOwnerName & "]"
  End If
  sBody = sBody & """, "

  If nCameraNumber <> -1 Then
    sBody = sBody & """device"" : " & nCameraNumber & ", "
  End If

  sBody = sBody & """data"" : """ & sQuestionText & " : " & sAnswerText & """ }"

  oHttpRequest.Send sBody

  If Err.number <> 0 Then
    DoHttpRequest = Array(1, " 0x" & Hex(Err.Number) & "  http . : " & Err.Description & " : " & Err.Source)
    Exit Function
  End If

  If oHttpRequest.Status <> 201 Then
    DoHttpRequest = Array(1, "Web- Devline Linia  : "& oHttpRequest.Status & " : " & oHttpRequest.StatusText)
    Exit Function
  End If

  '   201 - Created
  Dim strResponseBody : strResponseBody = oHttpRequest.ResponseText

  DoHttpRequest = Array(0, strResponseBody)
End Function

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function Base64Encode(sText)
  Dim oNode
  Set oNode = CreateObject("Msxml2.DOMDocument.3.0").CreateElement("base64")
  oNode.dataType = "bin.base64"
  oNode.nodeTypedValue = Stream_StringToBinary(sText)
  Base64Encode = oNode.text
  Set oNode = Nothing
End Function

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function Stream_StringToBinary(sText)
  Dim stream
  Set stream = CreateObject("ADODB.Stream")
  stream.Charset  = "utf-8"
  stream.Open
  stream.WriteText sText
  stream.Position = 0
  stream.Type = adTypeBinary
  stream.Position = 3   '  BOM
  Stream_StringToBinary = stream.Read
  stream.Close
End Function

